"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Namespace$ = void 0;
/*
 * Copyright (c) 2022-2023 AccelByte Inc. All Rights Reserved
 * This is licensed software from AccelByte Inc, for limitations
 * and restrictions contact your company contract manager.
 */
/**
 * AUTO GENERATED
 */
const sdk_1 = require("@accelbyte/sdk");
const NamespaceInfoArray_js_1 = require("../definitions/NamespaceInfoArray.js");
const NamespacePublisherInfo_js_1 = require("../definitions/NamespacePublisherInfo.js");
class Namespace$ {
    // @ts-ignore
    constructor(axiosInstance, namespace, cache = false) {
        this.axiosInstance = axiosInstance;
        this.namespace = namespace;
        this.cache = cache;
    }
    /**
     * Get all namespaces.&lt;br&gt;Other detail info: &lt;ul&gt;&lt;li&gt;&lt;i&gt;Required permission&lt;/i&gt;: login user&lt;/li&gt;&lt;li&gt;&lt;i&gt;Action code&lt;/i&gt;: 11303&lt;/li&gt;&lt;li&gt;&lt;i&gt;Returns&lt;/i&gt;: list of namespaces&lt;/li&gt;&lt;/ul&gt;
     */
    getNamespaces(queryParams) {
        const params = { ...queryParams };
        const url = '/basic/v1/public/namespaces';
        const resultPromise = this.axiosInstance.get(url, { params });
        const res = () => sdk_1.Validate.responseType(() => resultPromise, NamespaceInfoArray_js_1.NamespaceInfoArray, 'NamespaceInfoArray');
        if (!this.cache) {
            return sdk_1.SdkCache.withoutCache(res);
        }
        const cacheKey = url + sdk_1.CodeGenUtil.hashCode(JSON.stringify({ params }));
        return sdk_1.SdkCache.withCache(cacheKey, res);
    }
    /**
     * Get namespace info related publisher namespace.&lt;br&gt;Other detail info: &lt;ul&gt;&lt;li&gt;&lt;i&gt;Required permission&lt;/i&gt;: resource=&lt;b&gt;&#34;NAMESPACE:{namespace}:NAMESPACE&#34;&lt;/b&gt;, action=2 &lt;b&gt;(READ)&lt;/b&gt;&lt;/li&gt;&lt;li&gt;&lt;i&gt;Action code&lt;/i&gt;: 11305&lt;/li&gt;&lt;li&gt;&lt;i&gt;Returns&lt;/i&gt;: Namespace info related publisher namespace&lt;/li&gt;&lt;/ul&gt;
     */
    getPublisher() {
        const params = {};
        const url = '/basic/v1/public/namespaces/{namespace}/publisher'.replace('{namespace}', this.namespace);
        const resultPromise = this.axiosInstance.get(url, { params });
        const res = () => sdk_1.Validate.responseType(() => resultPromise, NamespacePublisherInfo_js_1.NamespacePublisherInfo, 'NamespacePublisherInfo');
        if (!this.cache) {
            return sdk_1.SdkCache.withoutCache(res);
        }
        const cacheKey = url + sdk_1.CodeGenUtil.hashCode(JSON.stringify({ params }));
        return sdk_1.SdkCache.withCache(cacheKey, res);
    }
}
exports.Namespace$ = Namespace$;
